\section{Introduction}
\label{sec:intro}
Real-time computing has traditionally been considered largely in the context of single-processor and embedded systems, and indeed, the terms real-time computing, embedded systems, and control systems are often mentioned in closely related
contexts. However, real-time computing in the context of multinode systems, specifically high-performance, cluster-computing systems, remains relatively unexplored. 
It can be argued that one reason for the relative dearth of work in this area 
is the lack of scenarios to date which would require such a system.
Previously \cite{rtss-wip, hui-sc}, we have motivated the emerging need for such an infrastructure, giving a specific
scenario related to the next generation North American electrical grid. 
%%%
%In that work, we described the amount of data projected to be generated
%by the future power grid, 
%%%
%%
In that work, we described the changes and challenges in the power grid driving the need
for much higher levels of \emph{computational resources} for power
grid operations.  To briefly summarize (and to provide some motivational
context for the current work), 
many of these computations--- particularly floating-point
intensive simulations and optimization calculations 
(\cite{fang,yousu, gao,gorton,ca})---%,Hetal:kalman09, jain,dse,stateest,zhao})---
can be more
effectively done in a centralized manner, and 
the amount and scale of such data is 
estimated by some \cite{rtss-wip, hui-sc} to be on the order of terabytes per day 
of streaming sensor data (e.g. Phasor Measurement Units (PMUs)), with the need to analyze the data within a strict 
cyclical window (every 30ms), presumably with the aid of high-performance,
parallel computing infrastructures.
With this in mind, the current work is part of a larger research effort at
Pacific Northwest National Laboratory aimed at developing the necessary
infrastructure to support an HPC cluster environment capable of processing
vast amounts of streaming sensor data under hard real-time constraints. 
%%%

While verifying the timing properties of a more traditional (e.g. embedded) real-time system
poses complex questions in its own right,
imposing real-time constraints on a parallel (cluster) computing environment introduces 
an entirely new set of challenges not seen in these more traditional environments.
For example, in addition to standard real-time concepts such as 
\emph{worst-case execution time} (WCET), real-time parallel computation introduces the necessity of 
considering \emph{worst case transmission time} when communicating over the network between nodes,
as well as the need to ensure that timing properties of one process do not invalidate those of the
entire parallel process as a whole. 

These are but two examples of the many questions which must
be addressed in a real-time parallel computing system; certainly there are many more questions
than can be addressed in a single paper. To this end, we introduce a simple,
event driven, automata-based model of computation intended to model the timing properties of  
a specific class of parallel programs. Namely, we consider 
SPMD (Single Program, Multiple Data), parent-child type programs, in part because
in practice, many parallel programs--- including many prototypical MPI-based \cite{mvapich,mpi}
programs--- fall into this category. We give an example of such a program in Section~\ref{sec:cases}. 
This model is typified by the existence of a cyclic
\emph{master} or \emph{parent} process, and a set of noncyclic \emph{child} or \emph{slave}
processes amongst which work is divided. With this characterization, a very natural
correspondence emerges between the processes and the automata which model them: the cyclic \emph{parent} process
is very naturally modeled by an  $\omega$-automaton, and the \emph{child} processes by a 
standard finite automaton.  
Our main contribution of this paper, then, is twofold: first, a formal method of modeling the respective processes in this manner,
combining these into a single hybrid system of parallel automata, and secondly, a simple case
study demonstrating a practical application of this system.  We should note that the notion 
of parallel finite automata is not a new one; variants
have been studied before (e.g. \cite{paraut,pfa}).
We take the novel approach of combining \emph{timed} variants (\cite{tba,tioa}) of finite automata 
into a single hybrid model which captures the timing properties of the various
component processes of a parallel system.

%We note in particular that this work is still, in some sense, exploratory work still in its early 
%stages. Namely, while we define the general problem and the corresponding computational machinery, 
%we, at the same time, introduce many interesting and important questions to which we do not yet fully
%know the answers. We consider the introduction of these open questions to be an equally 
%important part of this work.

%Existing RT model checkers. What they have done in the past, what 
%makes us unique.
The rest of the paper proceeds as follows: Section~\ref{sec:formal} defines the automaton models
used by our system: Timed Finite Automata in Section~\ref{sec:tafsa}, Timed \buchi Automata
in Section~\ref{sec:tba}, and a hybrid system combining these two models in Section~\ref{sec:pts}.
Section~\ref{sec:cases} gives a case study in the form of an example real-time matrix
multiplication kernel, running on a small, four-node real-time parallel cluster. 
Section~\ref{sec:concl} concludes.



\endinput
